#pragma once

#include <vector>
#include <chrono>
#include <freetype/freetype.h>

#include "../renderer/renderer.hpp"
#include "../callback.hpp"

namespace hibis {
	class Engine {
	public:
		Engine(Renderer* renderer, LoggerCallback logger);
		~Engine();

		float calculateDelta(bool isPhysics);

		void updateDelta(bool isPhysics);

		const char* getEngineVersion();

		FT_Library mFreeTypeLibrary;
	private:
		Renderer* mRenderer;
		//StopWatch watch;
		std::chrono::time_point<std::chrono::steady_clock> mPreviousProcessTick;
		std::chrono::time_point<std::chrono::steady_clock> mPreviousPhysicsProcessTick;

		LoggerCallback mLoggerCallback;
	};
}
